FORMAT: 1A

# Dashboard (Backend) API

The "Dashboard" is a API/ Application for Managing a Project (Update, Releases, Download Site, etc.).

The following HTML Status Codes are used for:<br>
- **200** OK    ;; No Errors, everything is okay
- **400** Error ;; Please see more Informations in the JSON Response

## Error Response
+ Body

```json
{
  "type": "ERROR",
  "message": "Error Message",
  "code": "001FFE",
  "more_info": "https://docs.my-domain.com/errors/001FFE"
}
```

+ Schema

```json
{
  "description": "Error Code Response",
  "type": "object",
  "properties": {
    "type": {
      "type": "string",
      "description": "The Error Type (eg. 'ERR_UNKNOW_ACTION')"
    },
    "message": {
      "type": "string",
      "description": "The Error Message (for the User or Developer; Contains useful/ more Informations about the Error)"
    },
    "code": {
      "type": "string",
      "description": "The (internal) Error Code of the Error. For Developers and to search Informations about this Error"
    },
    "more_info": {
      "type": "url",
      "description": "A Link to the Documentations for Help"
    }
  }
}
```

# Project [/]
All (default) API Request for managing a Project (Create, Delete; Create/ Delete Plan).

## Create Project [POST /create_project]
Create a new Project

+ Request (application/json)
    + Body
        ```json
        {
          "prj_name": "Test",
          "prj_comment": "A Project to Test the Backend",
          "download_site": true
        }
        ```
    + Schema
        ```json
        {
          "description": "Creating a new Project",
          "type": "object",
          "required": [ "prj_name", "download_site"],
          "properties" {
            "prj_name": {
              "type": "string",
              "description": "The Project Name"
            },
            "prj_comment": {
              "type": "string",
              "description": "A optional Comment to the Project"
            },
            "download_site": {
              "type": "boolean",
              "description": "Enable or Disable the automated Download Site"
            }
          }
        }
        ```

+ Response 200 (application/json)
    ```json
    {
      "prj_name": "Test",
      "prj_comment": "Project Comment",
      "download_site": true,
      "prj_id": 1
    }
    ```


## Add Plan to Project [POST /add_plan]

Create a Plan and add to a Project

+ Request (application/json)
    + Body
        ```json
        {
            "prj_id": 1,
            "plan_name": "Community Edition {$-$} Win", // everything after the '{$-$}' is a Comment (used for orientation) and will not be shown (eg.) at the Download Site.
            "os_id": "1,2,3",                           // All OS id's, seperated by ','
            "os_vid": "5,6,10",                         // All OS Version id's, seperated by ',' (for all Versions use 'ALL')
            "os_aid": "2,5,9"                           // All Architecture id's, seperated by ',' (to use all Architectures use 'ALL')
        }
        ```
    + Schema
        ```json
        {
          "description": "Add a new Plan to a Project",
          "type": "object",
          "required": [ "prj_id", "plan_name", "os_id", "os_vid", "os_aid" ],
          "properties": {
            "prj_id": {
              "type": "integer",
              "description": "The ID of the Project where to add the Plan"
            },
            "plan_name": {
              "type": "string",
              "description": "The Name of the Plan. [everything after the '{$-$}' is a Comment (used for orientation) and will not be shown (eg.) at the Download Site.]"
            },
            "os_id": {
              "type": "string",
              "description": "All OS id's, seperated by ','"
            },
            "os_vid": {
              "type": "string",
              "description": "All OS Version id's, seperated by ',' (for all Versions use 'ALL')"
            },
            "os_aid": {
              "type": "string",
              "description": "All Architecture id's, seperated by ',' (to use all Architectures use 'ALL')"
            }
          }
        }
        ```

+ Response 200 (application/json)
    + Body
        ```json
        {
          "ppid": "kRfq6",
          "prj_id": 5,
          "pl_id": 8
        }
        ```
    + Schema
        ```json
        {
          "type": "object",
          "properties": {
            "ppid": {
              "type": "string",
              "description": "A unique Project (and Plan) ID. [5 chars]"
            },
            "prj_id": {
              "type": "int",
              "description": "The ID of the Project where the Plan was added."
            },
            "pl_id": {
              "type": "int",
              "description": "The ID of the Plan"
            }
          }
        }
        ```

# OS [/os/]

Get Informations about the Avaible OS's.

The List of the Response is in this Format:
```
HEADER 1,HEADER 2,HEADER 3
CONTENT 1-1,CONTENT 1-2,CONTENT 1-3
CONTENT 2-1,CONTENT 2-2,CONTENT 2-3
CONTENT 3-1,CONTENT 3-2,CONTENT 3-3
CONTENT 4-1,CONTENT 4-2,CONTENT 4-3
CONTENT 5-1,CONTENT 5-2,CONTENT 5-3
```

There is an Parser at `${repo_root}/scripts/_scripts/printTable.sh`.<br>
Use the Parser as follows:<br>
```shell
~$ ./${repo_root}/scripts/_scripts/printTable.sh ',' "$(cat YOUR_FILE_WITH_CONTENT)"
```

It will print a Table like this:
```
+--------+--------------+
| OS ID  | System Name  |
+--------+--------------+
| 1      | Windows      |
| 2      | Linux        |
| 3      | OS X         |
+--------+--------------+
```


## List all OS's [GET /os/list_os]

Returns a List of all avaible Operating Systems and the ID of the Operating System.<br>

+ Response 200
    ```
    +--------+--------------+
    | OS ID  | System Name  |
    +--------+--------------+
    | 1      | Windows      |
    | 2      | Linux        |
    | 3      | OS X         |
    +--------+--------------+
    ```

## List all OS Versions [/os/get_version/{os_id}]

Returns a List of Versions from all avaible Operating Systems and the ID of the Operating System Version.<br>

+ Parameters
  + os_id: `5` (number, required) - The ID of the Operating System where to get the avaible Versions.

+ Response 200
    ```
    +----------------+----------+
    | OS Version ID  | Version  |
    +----------------+----------+
    | 1              | Vista    |
    | 2              | XP       |
    | 3              | 7        |
    | 4              | 8        |
    | 5              | 8.1      |
    | 6              | 10       |
    +----------------+----------+
    ```

## List all Architectures [/os/get_arch]

Returns a List of all avaible Architectures and the ID of the Architecture.

+ Response 200
    ```
    +----------+---------------+
    | Arch ID  | Architecture  |
    +----------+---------------+
    | 1        | ARM           |
    | 2        | x86           |
    | 3        | x86_64        |
    | 4        | arm64-v8a     |
    | 5        | amd64         |
    +----------+---------------+
    ```

# Group Other
All the other API Requests.

## Get Backend Informations [GET /info]
Get Informations from the Backend about the Backend (Version, etc.)

+ Response 200 (application/json)
    ```json
    {
      "version": "v1.0.0" // backend api version
    }
    ```

# Group Errors
<!-- TODO Check the Errors File (and look for a Documentation Engine) -->
[Click here](errors.apib) to go to the Errors Documentation.
